<?php
/**
 * This file acts as an interface for Drupal into PhpGedView.
 *
 * The module checks to see if the user is defined to phpGedView. If so
 * it logs them on, if not it adds them as a user to the system.
 *
 * This file belongs in the top level of the phpGedView folder.
 * All other integration files belong in a modules/phpgedview
 * directory in Drupal
 *
 */

global $users;
require ("config.php");

// external paths have a serialized value for $parms
// embedded paths have a path argument

if (!$path = urldecode($_REQUEST['path'])) {
  $path = 'index.php';
}

$path .= strstr($path, '?') ? '&' : '?';

$post_email = " ";
$post_user = "";

// create some variables in case they dont get in from the cookie
$def_canedit = "no";
$def_canadmin = "no";
$def_theme = " ";
$def_rootid = "I1";
$def_verified = "yes";
$def_verified_by_admin = "no";
$def_contact_method = "messaging2";
$def_gedcom = "";
$def_language = "english";
$def_upass = "";
$def_create_user = "no";
if (!$_COOKIE['pgv_permissions']) {
  exit;
}
$permissions = @unserialize(@base64_decode($_COOKIE['pgv_permissions']));
if (!is_array($permissions)) {
  exit;
}

// pick up cookie values
if (isset($permissions['def_canedit'])) $def_canedit = $permissions['def_canedit'];
if (isset($permissions['def_canadmin'])) $def_canadmin = $permissions['def_canadmin'];
if (isset($permissions['def_theme'])) $def_theme = $permissions['def_theme'];
if (isset($permissions['def_rootid'])) $def_rootid = $permissions['def_rootid'];
if (isset($permissions['def_verified'])) $def_verified = $permissions['def_verified'];
if (isset($permissions['def_verified_by_admin'])) $def_verified_by_admin = $permissions['def_verified_by_admin'];
if (isset($permissions['def_contact_method'])) $def_contact_method = $permissions['def_contact_method'];
if (isset($permissions['def_gedcom'])) $def_gedcom = $permissions['def_gedcom'];
if (isset($permissions['def_language'])) $def_language = $permissions['def_language'];
if (isset($permissions['def_upass'])) $def_upass = $permissions['def_upass'];
if (isset($permissions['def_create_user'])) $def_create_user = $permissions['def_create_user'];

if (isset($permissions['post_user'])) $post_user = $permissions['post_user'];
if (isset($permissions['post_email'])) $post_email = $permissions['post_email'];

if (!empty($post_user)) {

	// need to add the user into gedview - but only if def_create_user says its ok
  if (!getUser($post_user) and ($def_create_user == "yes") ) {
    $newuser = array();
    $newuser["username"] = $post_user;
    $newuser["firstname"] = '';
    $newuser["lastname"] = '';
    $newuser["canedit"] = array();
    if ($def_canedit == "yes") {
      $newuser["canedit"][$def_gedcom] = "yes";
    } else {
      $newuser["canedit"][$def_gedcom] = "";
    }
    $newuser["gedcomid"] = array();
    $newuser["gedcomid"][$def_gedcom] = '';
    $newuser["rootid"] = array();
    $newuser["rootid"][$def_gedcom] = $def_rootid;
    $newuser["canadmin"] = $def_canadmin;
    $newuser["email"] = $post_email;
    $newuser["verified"] = "yes";
    $newuser["verified_by_admin"] = $def_verified_by_admin;
    $newuser["pwrequested"] = "";
    $newuser["theme"] = $def_theme;
    $newuser["language"] = $def_language;
    $newuser["reg_timestamp"] = date("U");
    $newuser["reg_hashcode"] = "";
    $newuser["loggedin"] = "N";
    $newuser["sessiontime"] = 0;
    $newuser["contactmethod"] = $def_contact_method;
    $newuser["password"] = crypt($def_upass);

    $newuser["visibleonline"] = 'Y';
    $newuser["editaccount"] = 'Y';
    $newuser["default_tab"] = 0;
    $newuser["comment"] = '';
    $newuser["comment_exp"] = '';
    $newuser["sync_gedcom"] = '';
    $newuser["relationship_privacy"] = '';
    $newuser["max_relation_path"] = '';
    $newuser["auto_accept"] = '';

    addUser($newuser, "added");
  }
  $my_user = getUser($post_user);
  $admin_ver = $my_user["verified_by_admin"] ;

  // is the user there and verified ?
  if (getUser($post_user) and ($admin_ver == "yes")) {
    $sql = "UPDATE ".$TBLPREFIX."users SET u_loggedin='Y', u_sessiontime='".time()."' WHERE u_username='$post_user'";
    $res = dbquery($sql);
    if ($post_user != "admin") {
      $sql = "UPDATE ".$TBLPREFIX."users SET u_canadmin='N' WHERE u_username='$post_user'";
      $res = dbquery($sql);
    }

    AddToLog("Drupal Login Successful ->" . $post_user ."<-");
    $_SESSION['pgv_user'] = $post_user;
    $url = $path; // . session_name() ."=". session_id();
    $url.="command=gedcom";
  } else {
    $url = $path ."logout=1";
  }
} else {
  $url = $path ."logout=1";
}

header("Location: $url");
exit;

